<template>
  <div>
    <div class="while-waiting" v-show="this.promoList.length==0">
      <img src="https://media.giphy.com/media/55mcm80T6alKjcuO5q/giphy.gif" alt="waiting" />
    </div>
    <div class="promos" v-show="this.promoList.length !==0">
      <h1>NUESTRAS PROMOS</h1>
      <section class="cards-wrapper">
        <div v-for="(promo, index) in promoList" :key="index">
          <PromoBox
            class="promo-box"
            @go-to-this-product-details="goTOProductDetails"
            :promo="promo"
          />
        </div>
      </section>
    </div>

  </div>
</template>

<script>
import PromoBox from './PromoBox.vue'

import API from '@/API.js'
export default {
  name: 'promosList',
  components: {
    PromoBox
  },
  props: {},
  data() {
    return {
      idActualUser: '',
      promoList: []
    }
  },
  async mounted() {
    this.idActualUser = this.$route.params.idActualUser

    await this.PutResultLoadProductListEnData()
  },
  methods: {
    async loadCategories() {
      this.categories = await API.loadCategories()
    },
    async searchProductByName() {
      const searchedWord = this.searchedProductsName
      this.productList = await API.searchProductByName(searchedWord)
    },

    async PutResultLoadProductListEnData() {
      this.promoList = await API.loadPromoList()
    },

    async PutResultLoadProductDetailsEnData() {
      let searchedCategory = this.searchedCategory
      this.productList = await API.loadProductsDetailsBySearchedCategory(
        searchedCategory
      )
      if (this.productList.categoria === 'false') {
        this.showThis = true
        this.galeryHasShow = false
      }
    },

    async searchForProductsPerCategory() {
      this.showThis = false
      this.galeryHasShow = true
      if (this.searchedCategory === 'All-Categories') {
        await this.PutResultLoadProductListEnData()
      } else {
        await this.PutResultLoadProductDetailsEnData()
      }
    },

    goTOProductDetails(id_product) {
      if (this.idActualUser === undefined) {
        this.$router.push('/product-detail/' + id_product)
      } else {
        this.$router.push(
          '/product-detail/' + this.idActualUser + '/' + id_product
        )
      }
    }
  }
}
</script>


<style scoped>
.cards-wrapper {
  display: grid;
  justify-content: center;
  align-items: center;
  grid-template-columns: 1fr 1fr 1fr 1fr;
  grid-gap: 4rem;
  padding: 4rem;
  margin: 0 auto;
  width: max-content;
}
@media screen and (max-width: 1285px) {
  .cards-wrapper {
    grid-template-columns: 1fr 1fr;
  }
}

@media screen and (max-width: 900px) {
  .cards-wrapper {
    grid-template-columns: 1fr;
  }
  .info {
    justify-content: center;
  }
  .card-grid-space .num {
    /margin-left: 0;
    /text-align: center;
  }
}

@media screen and (max-width: 500px) {
  .cards-wrapper {
    padding: 4rem 2rem;
  }
  .card {
    max-width: calc(100vw - 4rem);
  }
}

@media screen and (max-width: 450px) {
  .info {
    display: block;
    text-align: center;
  }
  .info h1 {
    margin: 0;
  }
}
</style>
